#COMPILE EXE
#DIM ALL
'#INCLUDE "Win32api.inc"
'#INCLUDE "ComDlg32.inc"
'#INCLUDE "CommCtrl.inc"
#INCLUDE "GrocListAPI.inc"
#INCLUDE "GrocList.inc"
#INCLUDE "myMsgbox.inc"
'#INCLUDE "debug.inc" 
#RESOURCE "GrocList.pbr" 'for application icon

'GLOBAL dbug AS LONG
$VerNo = "1.50"
$Prog = "GrocList " + $VerNo
FUNCTION PBMAIN()
   LOCAL nStyle, noSort, wi, ht, top, LBht, bottom AS LONG, s, ti AS STRING
   ti = "Grocery List": nStyle = %WS_SYSMENU + %WS_MINIMIZEBOX
   wi = 505: ht = 400: top = 35: LBht = 220: bottom = top + LBht
   DIALOG NEW PIXELS, 0, ti, , , wi, ht, nStyle TO hMain
   noSort = %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS OR %WS_VSCROLL OR %WS_TABSTOP
   CONTROL ADD LISTBOX, hMain, %IDC_MainLB, , 10, top, wi - 25, LBht, noSort
   CONTROL ADD LABEL, hMain, -1, "Buy", 10, top - 15, 25, 15, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hMain, -1, "  Grocery Item", 35, top - 15, 130, 15, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hMain, -1, "  Unit Description", 165, top - 15, 130, 15, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hMain, -1, "   Last buy", 295, top - 15, 60, 15, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hMain, -1, "       Units", 355, top - 15, 60, 15, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hMain, -1, "        Cost", 415, top - 15, 60, 15, %SS_LEFT, %WS_EX_STATICEDGE

   CONTROL ADD LABEL, hMain, -1, "Units to buy", 100, bottom + 20, 120, 15
   CONTROL ADD TEXTBOX, hMain, %IDC_Units, "", 35, bottom + 20, 60, 18

   CONTROL ADD BUTTON, hMain, %IDCANCEL, "", 0, 0, 0, 0, %BS_CENTER
   CONTROL ADD BUTTON, hMain, %IDC_NewItem, "&New Item", 300, bottom + 20, 70, 30, %BS_CENTER
   CONTROL ADD BUTTON, hMain, %IDC_AutoList, "&Auto List", 372, bottom + 20, 70, 30, %BS_CENTER
   CONTROL ADD BUTTON, hMain, %IDC_PrnList, "&Print List", 300, bottom + 50, 70, 30, %BS_CENTER
   CONTROL ADD BUTTON, hMain, %IDC_CheckOut, "&Check Out", 372, bottom + 50, 70, 30, %BS_CENTER
   s = "Double-click item in listbox, press Return," + $CRLF _
     + ".... or enter number of units to buy above" + $CRLF _
     + ".... can also press right mouse button"
   CONTROL ADD LABEL, hMain, -1, s, 10, bottom + 55, 220, 50
   CONTROL SET FOCUS hMain, %IDC_MainLB
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL fileNo, i, j, k, n, x, y, flags, curItem AS LONG
   LOCAL hInst, hIcon, numUnits AS LONG, v AS SINGLE
   LOCAL s, ti, f, path, filter AS STRING, pt AS POINTAPI, z AS dateType
   STATIC hEdit, hMainLB, numBackup AS LONG
   STATIC u AS SINGLE, helpFile AS ASCIIZ * 240
   SELECT CASE CBMSG
'  OPEN "log.txt" FOR APPEND AS #1
'  PRINT #1, WindowMessage(CBMSG), TIME$, STR$(CBWPARAM), STR$(CBLPARAM)
'  CLOSE #1
      CASE %WM_INITDIALOG
         'show application icon
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "grocery", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, 0, hIcon
         helpFile = CURDIR$ + "\grocList.chm"
            numItems = 0
            REDIM items(numItems)
            REDIM order(numItems)
         addMenu
         addStatusbar
         initMainLB 
         thisFile = "my Grocery List.grl"
         IF LEN(DIR$("grocList.ini")) THEN
            fileNo = FREEFILE
            OPEN "grocList.ini" FOR INPUT AS #fileNo
            INPUT #fileNo, s
            CLOSE #fileNo
            IF LEN(s) THEN thisFile = s
         END IF
         IF LEN(DIR$(thisFile)) THEN 
            openTheFile
         ELSE
            numItems = 0: numCatgs = 0
            REDIM items(0), order(0), catgs(0)
         END IF   
         'setup subclass of textbox %IDC_Units to capture Up, Down, and Return
         CONTROL HANDLE CBHNDL, %IDC_Units TO hEdit
         gOrigEditProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(subClassEditProc))
         'setup subclass of listbox %IDC_MainLB to capture Return
         CONTROL HANDLE CBHNDL, %IDC_MainLB TO hMainLB
         gOrigLBProc = SetWindowLong(hMainLB, %GWL_WNDPROC, CODEPTR(subClassLBProc))
         CONTROL ADD LINE, CBHNDL, 999, "", 8, 20, 483, 227, %SS_BLACKFRAME
         helpFile = CURDIR$ + "\GrocList.chm"
         reorderList
      CASE %WM_MENUSELECT
         CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
         IF BIT(items(order(n)).flag, 0) THEN s = "Don't buy" ELSE s = "Buy"
         MENU SET TEXT hTaskMenu, BYCMD %IDM_Buy, s
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDM_Open
               IF fileChanged THEN
                  s = "Do you want to save the current file?"
                  ti = "Modified File" 
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
                  IF n = %IDYES THEN saveTheFile
               END IF
               Path = CURDIR$ 
               filter = "Grocery lists (*.grl)|*.grl|All Files (*.*)|*.*"
               'flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES OR %OFN_EXPLORER 'OR %OFN_FILEMUSTEXIST
               flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES OR %OFN_CREATEPROMPT OR _ 
                       %OFN_EXTENSIONDIFFERENT OR %OFN_EXPLORER 
               OpenFileDialog CBHNDL, "Open File", f, BYVAL path, filter, "", flags
               IF LEN(f) THEN thisFile = f: openTheFile: listItems 1
            CASE %IDM_Save
               n = MSGBOX("Save file now?", %MB_YESNO + %MB_ICONQUESTION, "Save File")
               IF n = %IDYES THEN
                 IF LEN(thisFile) THEN
                    fileChanged = 1: saveTheFile
                 ELSE
                    DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_SaveAs, 0
                 END IF
               END IF
            CASE %IDM_SaveAs
               IF LEN(thisFile) = 0 THEN thisFile = "My grocery list"
               path = CURDIR$: f = thisFile
               filter = "Grocery lists (*.grl)|*.grl|All Files (*.*)|*.*"
               flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               IF ISTRUE (SaveFileDialog(CBHNDL, "Save File", f, path, filter, "grl", flags)) THEN
                    thisFile = f: saveTheFile: listItems
               END IF
            CASE %IDM_ResetAll
               s = "Are you sure you wish to reset all items?" + $CRLF +_
                   "... This will remove buying histories of all items"
               n = MSGBOX(s, %MB_YESNO OR %MB_ICONERROR, "Reset All Items")
               IF n = %IDYES THEN
                  FOR i = 1 TO numItems
                     FOR j = 1 TO 5
                        items(i).kDates(j) = z
                     NEXT j
                     FOR j = 1 TO 5
                        items(i).kUnits(j) = 0
                     NEXT j   
                  NEXT i
                  fileChanged = 1: listItems 
               END IF
            CASE %IDM_Print
               printList 
            CASE %IDM_Exit
               DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0   
            CASE %IDM_New
               addItem
            CASE %IDM_Chg
               CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n
               INCR n: IF n > 0 THEN addItem n
            CASE %IDM_Delete
               s = "Delete this item now?"
               n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Delete Item")
               IF n = %IDYES THEN
                  CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n
                  INCR n: deleteItem n
               END IF
            CASE %IDM_Reset
               s = "Reset this item now?" + $CRLF +_
                   "... buying history will be removed"
               n = MSGBOX(s, %MB_YESNO OR %MB_ICONERROR, "Reset All Items")
               IF n = %IDYES THEN
                  CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
                  FOR j = 1 TO 5
                     items(order(n)).kDates(j) = z
                  NEXT j
                  FOR j = 1 TO 5
                     items(order(n)).kUnits(j) = 0
                  NEXT j   
                  fileChanged = 1: listItems 
               END IF
            CASE %IDM_BuyUnits
               CONTROL SEND CBHNDL, %IDC_Units, %EM_SETSEL, 0, -1 
               CONTROL SET FOCUS CBHNDL, %IDC_Units
            CASE %IDM_UnitsHist
               CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
               IF BIT(items(order(n)).flag, 1) THEN
                  s = "No history"
               ELSE   
                  s = "  Date" + SPACE$(12) + "Units" + $CRLF + $CRLF
                  FOR i = 1 TO 5
                     IF items(order(n)).kDates(i).day = 0 THEN EXIT FOR
                     f = FORMAT$(items(order(n)).kUnits(i), "#.00")
                     s = s + getDate(items(order(n)).kDates(i)) + SPACE$(12 - LEN(f)) + f + $CRLF
                  NEXT i 
               END IF
               myMsgbox s, %MB_ICONINFORMATION, "Units History"
            CASE %IDM_Buy
               CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
               k = BIT(items(order(n)).flag, 0): k = ABS(k - 1)
               BIT RESET items(order(n)).flag, 2
               BIT CALC items(order(n)).flag, 0, k
               listItems -n: fileChanged = 1
               items(order(n)).nUnits = k 
               IF k THEN s = "1"
               CONTROL SET TEXT CBHNDL, %IDC_Units, s 
               IF BIT(items(order(n)).flag, 0) THEN
                  CONTROL SET FOCUS CBHNDL, %IDC_Units
                  CONTROL SEND CBHNDL, %IDC_Units, %EM_SETSEL, 0, -1
               END IF
            CASE %IDM_Catg
               categories   
            CASE %IDM_PrnList
               printList 1
            CASE %IDM_CheckOut
               IF totalToBuy THEN
                  s = "Did you buy all of the checked items?"
                  n = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Check out")
                  IF n = %IDYES THEN
                     numBackUp = numItems
                     REDIM backUp(numItems), backUpOrder(numItems)
                     FOR i = 1 TO numItems
                        backUp(i) = items(i)
                        backUpOrder(i) = order(i)
                     NEXT i
                     checkout
                  ELSE
                     s = "First, update items bought... " + $CRLF _
                       + "and then return to check out" 
                     MSGBOX s, %MB_ICONINFORMATION, "CHECK OUT"
                  END IF
               END IF
            CASE %IDM_UndoCheckOut
               n = MSGBOX("Undo check out now?", %MB_YESNO, "Check out")
               IF n = %IDYES THEN
                  numItems = numBackUp
                  REDIM items(numItems), order(numItems)
                  FOR i = 1 TO numItems
                     items(i) = backUp(i)
                     order(i) = backUpOrder(i)
                  NEXT i
                  listItems 
               END IF
            CASE %IDM_Help
               HtmlHelp CBHNDL, helpFile, 0, 0
            CASE %IDM_About
               about
            CASE %IDC_MainLB
               IF CBCTLMSG = %LBN_SETFOCUS OR CBCTLMSG = %LBN_SELCHANGE THEN
                  setStatusbar
                  IF CBCTLMSG = %LBN_SETFOCUS THEN 
                     CONTROL SHOW STATE CBHNDL, 999, %SW_SHOW
                  END IF
                  CONTROL SEND CBHNDL, CBCTL, %LB_GETCURSEL, 0, 0 TO n: INCR n
                  update = 1: listboxItem = n: editMode = 0
                  u = items(order(n)).nUnits: update = -1
                  IF u THEN s = FORMAT$(u, "#.00") ELSE s = ""
                  CONTROL SET TEXT CBHNDL, %IDC_Units, s
               ELSEIF CBCTLMSG = %LBN_DBLCLK THEN
                  DIALOG SEND CBHNDL, %WM_USER + 500, 0, 0
               ELSEIF CBCTLMSG = %LBN_KILLFOCUS THEN
                  CONTROL SHOW STATE CBHNDL, 999, %SW_HIDE
               END IF
            CASE %IDC_Units
               IF CBCTLMSG = %EN_SETFOCUS THEN
                  update = 1: editMode = 1
               ELSEIF CBCTLMSG = %EN_KILLFOCUS THEN
                  update = 0
               ELSEIF CBCTLMSG = %EN_CHANGE AND update > 0 THEN
                  CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
                  numUnits = items(order(n)).nUnits
                  CONTROL GET TEXT CBHNDL, CBCTL TO s: s = TRIM$(s)
                  IF VAL(s) <> numUnits THEN fileChanged = 1
                  items(order(n)).nUnits = VAL(s)
                  IF LEN(s) THEN
                     BIT SET items(order(n)).flag, 0
                  ELSE
                     BIT RESET items(order(n)).flag, 0
                  END IF 
                  BIT RESET items(order(n)).flag, 2
                  listItems(-n): setStatusbar
                  update = 1
               END IF
            CASE %IDC_NewItem
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_New, 0   
            CASE %IDC_AutoList
               k = 0
               FOR n = 1 TO numItems
                  i = order(n): v = predictUnits(i)
                  IF items(i).nUnits THEN ITERATE
                  IF v >= 1 THEN 
                     items(i).nUnits = v: k = 1 
                     BIT SET items(i).flag, 0: BIT SET items(i).flag, 2
                  END IF
               NEXT n
               IF k THEN listItems
            CASE %IDC_PrnList
               printList 1
            CASE %IDC_CheckOut
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_CheckOut, 0
            CASE %IDCANCEL
               DIALOG END CBHNDL
         END SELECT 
         IF CBCTL >= %IDC_NewItem AND CBCTL <= %IDC_CheckOut THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END IF
      CASE %WM_USER + 500 'item double clicked or Return pressed
         CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
         IF BIT(items(order(n)).flag, 2) THEN
            BIT RESET items(order(n)).flag, 2
         ELSEIF BIT(items(order(n)).flag, 0) THEN 
            items(order(n)).nUnits = 0
            BIT RESET items(order(n)).flag, 0
         ELSE
            items(order(n)).nUnits = 1
            BIT SET items(order(n)).flag, 0
         END IF
         listItems -n: fileChanged = 1
         k = items(order(n)).nUnits: IF k THEN s = STR$(k) 
         CONTROL SET TEXT CBHNDL, %IDC_Units, s
         IF BIT(items(order(n)).flag, 0) THEN
            CONTROL SET FOCUS CBHNDL, %IDC_Units
            CONTROL SEND CBHNDL, %IDC_Units, %EM_SETSEL, 0, -1
         END IF
      CASE %WM_CONTEXTMENU  ' right-click mouse for floating menu
         pt.x = LOWRD(CBLPARAM ): pt.y = HIWRD(CBLPARAM )
         ScreenToClient CBWPARAM,pt
         CurItem = LOWRD(SendMessage(CBWPARAM, %LB_ITEMFROMPOINT, 0, MAKLNG(pt.x, pt.y)))
         SendMessage CBWPARAM, %LB_SETCURSEL, CurItem, 0
         CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
         s = FORMAT$(items(order(n)).nUnits, "#.00"): IF VAL(s) = 0 THEN s = ""
         update = 0: CONTROL SET TEXT CBHNDL, %IDC_Units, s
         CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
         IF BIT(items(order(n)).flag, 0) THEN s = "Don't buy" ELSE s = "Buy"
         MENU SET TEXT hMouseMenu, BYCMD %IDM_Buy, s
         TrackPopupMenu hMouseMenu, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, _
                     LOWRD(CBLPARAM), HIWRD(CBLPARAM), 0, CBHNDL, BYVAL %NULL
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE AND fileChanged THEN
            s = "File records have changed..." + $CRLF + "do you want to save them?"
            n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
            IF n = %IDCANCEL THEN
               FUNCTION = 1: EXIT FUNCTION
            ELSEIF n = %IDYES THEN
               IF LEN(thisFile) THEN
                  saveTheFile
               ELSE
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_SaveAs, 0
               END IF
            END IF
         END IF
      CASE %WM_DESTROY
         'Important! Remove the subclassing 
         SetWindowLong hEdit, %GWL_WNDPROC, gOrigEditProc
         SetWindowLong hMainLB, %GWL_WNDPROC, gOrigLBProc
   END SELECT
END FUNCTION

FUNCTION subClassEditProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   STATIC n AS LONG
   'to detect textbox return and up, down
   SELECT CASE wMsg&
      CASE %WM_KEYUP
         IF wParm& = %VK_RETURN OR wParm& = %VK_UP OR wParm& = %VK_DOWN THEN
            CONTROL SEND hMain, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
            IF n > 1 AND wParm& = %VK_UP THEN DECR n
            IF n < numItems AND wParm& = %VK_DOWN THEN INCR n
            CONTROL SEND hMain, %IDC_MainLB, %LB_SETCURSEL, n - 1, 0
            fillEntryBox n: update = 1
            CONTROL SET FOCUS hMain, %IDC_MainLB
         END IF
   END SELECT
   'pass the message on to the original window procedure
   FUNCTION = CallWindowProc(gOrigEditProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION 

FUNCTION subClassLBProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG 
   SELECT CASE wMsg&
      CASE %WM_KEYUP
         IF wParm& = %VK_RETURN THEN
            IF noReturn = 0 THEN DIALOG SEND hMain, %WM_USER + 500, 0, 0
            noReturn = 0  
         END IF 
   END SELECT
   'pass the message on to the original window procedure
   FUNCTION = CallWindowProc(gOrigLBProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB addMenu()
   MENU NEW BAR TO hMenu
   'declare menu popUps
   MENU NEW POPUP TO hFileMenu
   MENU NEW POPUP TO hEditMenu
   MENU NEW POPUP TO hTaskMenu
   MENU NEW POPUP TO hHelpMenu
   'fill out top menus
   MENU ADD POPUP, hMenu, "&File", hFileMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Task", hTaskMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu,%MF_ENABLED
   'fill out drop down menus
   MENU ADD STRING, hFileMenu, "&Open", %IDM_Open,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %IDM_Save,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %IDM_SaveAs,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Reset all", %IDM_ResetAll,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Print all", %IDM_Print,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit", %IDM_Exit,%MF_ENABLED
   MENU ADD STRING, hEditMenu, "&New item", %IDM_New, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Change item", %IDM_Chg, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Delete item", %IDM_Delete, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Reset item", %IDM_Reset, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Buying history", %IDM_UnitsHist, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Buy", %IDM_Buy, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "-", 0, 0
   MENU ADD STRING, hTaskMenu, "&Categories", %IDM_Catg, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Print list", %IDM_PrnList,%MF_ENABLED
   MENU ADD STRING, hTaskMenu, "-", 0, 0
   MENU ADD STRING, hTaskMenu, "Check &Out", %IDM_Checkout,%MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Undo Checkout", %IDM_UndoCheckOut,%MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&Help", %IDM_Help,%MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %IDM_About,%MF_ENABLED
   'put menu system on window
   MENU ATTACH hMenu, hMain         
   
   'create right click floating menu (must destroyMenu hMouseMenu)
   MENU NEW POPUP TO hMouseMenu
   MENU ADD STRING, hMouseMenu, "Buy", %IDM_Buy, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Change item", %IDM_Chg, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Delete item", %IDM_Delete, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Units to buy", %IDM_BuyUnits, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Units history", %IDM_UnitsHist, %MF_ENABLED
END SUB

SUB addStatusbar()
   'right edge of parts are defined by sbParts()
   DIM sbParts(3) AS LONG
   hStatus = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, hMain, 200)
   sbParts(0) = 170
   sbParts(1) = 290
   sbParts(2) = 395
   sbParts(3) = -1      'sets last one to right edge
   SendMessage(hStatus, %SB_SETPARTS, 4, BYVAL VARPTR(sbParts(0)))
END SUB

SUB setStatusbar()
   LOCAL n, k AS LONG, s AS STRING
   CONTROL SEND hMain, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n: INCR n
   k = order(n) 
   's = catgs(items(k).catg)
   s = "Catg: " + catgs(items(k).catg)
   SendMessage hStatus, %SB_SETTEXT, 0, BYVAL STRPTR(s) 
   IF BIT(items(k).flag, 1) THEN s = "Special buy" ELSE s = ""
   SendMessage hStatus, %SB_SETTEXT, 1, BYVAL STRPTR(s)
   s = "Items to buy: " + STR$(totalToBuy)
   SendMessage hStatus, %SB_SETTEXT, 2, BYVAL STRPTR(s)
   s = "Total cost: " + FORMAT$(totalCost, "#.00")
   SendMessage hStatus, %SB_SETTEXT, 3, BYVAL STRPTR(s)
END SUB

SUB initMainLB()
   DIM lptr AS LONG PTR
   DIM tabstops(5) AS LONG
   tabstops(0) = 3
   'tabstops(1) = 15
   tabstops(1) = 20 '38
   tabstops(2) = 107 '125
   tabstops(3) = 194 '212
   tabstops(4) = -257 '-275
   tabstops(5) = -297 '-315
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hMain, %IDC_MainLB, %LB_SETTABSTOPS, 6, lptr 
END SUB

SUB listItems(OPT BYVAL nOpt AS LONG)
   'nOpt > 0  list all lines and hiLite line nOpt
   'nOpt = 0  list all lines and leave hiLited line as is
   'nOpt < 0  change single line and leave it hiLited
   '---------------------------------------------------------------------
   LOCAL i, j, k, hiLite, top AS LONG, v, vcost AS DOUBLE
   LOCAL s, ss AS STRING, sz AS ASCIIZ * 1024
   IF numItems = 0 THEN EXIT SUB
   hiLite = ABS(nOpt) - 1: update = 1
   IF nOpt = 0 THEN 'save hiLite line
      CONTROL SEND hMain, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO hiLite 
      hiLite = MAX(hiLite, 0)
   END IF
   IF nOpt < 0 THEN 'change single line
      j = ABS(nOpt): i = order(j): GOSUB getLineStr: sz = s: DECR j
      CONTROL SEND hMain, %IDC_MainLB, %LB_DELETESTRING, j, 0
      CONTROL SEND hMain, %IDC_MainLB, %LB_INSERTSTRING, j, VARPTR(sz)
   ELSE
      CONTROL SEND hMain, %IDC_MainLB, %LB_GETTOPINDEX, 0, 0 TO top
      LISTBOX RESET hMain, %IDC_MainLB
      FOR j = 1 TO numItems
         i = order(j): GOSUB getLineStr
         LISTBOX ADD hMain, %IDC_MainLB, s
      NEXT j
      CONTROL SEND hMain, %IDC_MainLB, %LB_SETTOPINDEX, top, 0
   END IF
   'now, hiLite appropriate line and fill entry box 
   CONTROL SEND hMain, %IDC_MainLB, %LB_SETCURSEL, hiLite, 0
   IF editMode = 0 THEN fillEntryBox hiLite + 1:
   totalToBuy = 0: totalCost = 0
   FOR i = 1 TO numItems
      IF BIT(items(order(i)).flag, 0) THEN 
         INCR totalToBuy: totalCost = totalCost + items(order(i)).cost
      END IF
   NEXT i
   setStatusbar
   EXIT SUB
   
   'get string variable s for line ------------------------------------------------
   getLineStr:
      s = "": ss = ""
      IF BIT(items(i).flag, 0) THEN
         IF BIT(items(i).flag, 2) THEN ss = "X" ELSE ss = "x"
      END IF
      s = $TAB + ss: k = LEN(ss)
      s = s + $TAB + TRIM$(items(i).item) + $TAB + TRIM$(items(i).unit)
      s = s + $TAB + getLastDate(i)
      IF k THEN
         v = items(i).nUnits: vcost = v * items(i).cost
         IF v THEN s = s + $TAB + FORMAT$(v, "#.00")
         IF vcost THEN s = s + $TAB + FORMAT$(vcost, "#.00")
      END IF
      RETURN
END SUB

FUNCTION truncateStr(hCtrl AS LONG, s AS STRING, cxPixels AS LONG) AS STRING
   'return maximum length string that fits in cxPixels
   'hCtrl    - handle of control that string is writen to
   's        - string to be truncated
   'cxPixels - truncated length of string in pixels
   '-----------------------------------------------------------------------------
   LOCAL nFit, hdc, hFont AS LONG
   LOCAL szText AS ASCIIZ*256, cSize AS SIZEL
   szText = s: hdc = GetDC(hCtrl)
   hFont = SendMessage(hCtrl, %WM_GETFONT, 0, 0)
   SelectObject(hdc, hFont)
   GetTextExtentExPoint hDC, BYVAL VARPTR(szText), LEN(szText), cxPixels, _
                       BYVAL VARPTR(nFit), BYVAL %NULL, BYVAL VARPTR(cSize)
   ReleaseDC hCtrl, hDC
   FUNCTION = LEFT$(s, nFit)
END FUNCTION

SUB fillEntryBox(n AS LONG)
   LOCAL u AS SINGLE, s AS STRING 
   update = 0: u = items(order(n)).nUnits
   IF u THEN s = TRIM$(STR$(u)) ELSE s = ""
   CONTROL SET TEXT hMain, %IDC_Units, s 
END SUB

SUB addItem(OPT BYVAL itemNo AS LONG)
   LOCAL hAddItem, wi, ht, nStyle AS LONG, s AS STRING
   wi = 240: ht = 220: 'itemNo = nItem
   DIALOG NEW PIXELS, hMain, "Add Item", , , wi, ht, %WS_SYSMENU TO hAddItem
   CONTROL ADD LABEL, hAddItem, -1, "Grocery item:", 10, 10, 70, 15
   CONTROL ADD LABEL, hAddItem, -1, "Unit Descr:", 10, 35, 70, 15
   CONTROL ADD LABEL, hAddItem, -1, "Category:", 10, 60, 70, 15
   CONTROL ADD LABEL, hAddItem, -1, "Price/unit:", 10, 85, 70, 15
   CONTROL ADD TEXTBOX, hAddItem, %IDC_Item, "", 85, 10, 130, 20
   CONTROL ADD TEXTBOX, hAddItem, %IDC_Unit, "", 85, 35, 130, 20
   nStyle = %CBS_DROPDOWNLIST OR %WS_VSCROLL OR %WS_TABSTOP 'OR %CBS_DISABLENOSCROLL
   CONTROL ADD COMBOBOX, hAddItem, %IDC_Catg, , 85, 60, 100, 100, nStyle
   CONTROL ADD TEXTBOX, hAddItem, %IDC_Price, "", 85, 85, 80, 20
   s = "Special one time buy - no history kept"
   CONTROL ADD CHECKBOX, hAddItem, %IDC_Special, s, 10, 120, 200, 20
   CONTROL ADD BUTTON, hAddItem, %IDOK, "&Ok", 90, ht - 50, 60, 30
   CONTROL ADD BUTTON, hAddItem, %IDCANCEL, "&Cancel", 160, ht - 50, 60, 30
   DIALOG SET USER hAddItem, 1, itemNo
   DIALOG SHOW MODAL hAddItem CALL addItemProc
END SUB

CALLBACK FUNCTION addItemProc()
   LOCAL i, n, hCtrl, editNo AS LONG
   LOCAL s1, s2, s3 AS STRING, sz AS ASCIIZ * 32
   STATIC itemNo, buy, nBuy, special AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SEND CBHNDL, %IDC_Item, %EM_SETLIMITTEXT, 20, 0
         CONTROL SEND CBHNDL, %IDC_Unit, %EM_SETLIMITTEXT, 20, 0
         DIALOG GET USER CBHNDL, 1 TO itemNo:
         editNo = order(itemNo)
         IF numCatgs THEN
            COMBOBOX RESET CBHNDL, %IDC_Catg
            FOR i = 1 TO numCatgs
               COMBOBOX ADD CBHNDL, %IDC_Catg, catgs(i)
            NEXT i
         END IF
         IF editNo THEN 'edit mode
            DIALOG SET TEXT CBHNDL, "Change Item"
            CONTROL SEND CBHNDL, %IDC_MainLB, %LB_GETCURSEL, 0, 0 TO n
            CONTROL SET TEXT CBHNDL, %IDC_Item, TRIM$(items(editNo).item)
            CONTROL SET TEXT CBHNDL, %IDC_Unit, TRIM$(items(editNo).unit)
            IF BIT(items(editNo).flag, 0) THEN buy = 1 ELSE buy = 0
            IF BIT(items(editNo).flag, 1) THEN special = 1 ELSE special = 0
            nBuy = items(editNo).nUnits
            sz = catgs(items(editNo).catg)
            CONTROL SEND CBHNDL, %IDC_Catg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO i
            CONTROL SEND CBHNDL, %IDC_Catg, %CB_SETCURSEL, i, 0
            IF items(editNo).cost THEN
               CONTROL SET TEXT CBHNDL, %IDC_Price, STR$(items(editNo).cost)
            END IF
            CONTROL SET CHECK CBHNDL, %IDC_Special, special
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDC_Special THEN
            CONTROL SET FOCUS CBHNDL, %IDC_Item
            special = 1
         ELSEIF CBCTL = %IDOK THEN
            CONTROL GET TEXT CBHNDL, %IDC_Item TO s1
            IF LEN(s1) = 0 THEN DIALOG END CBHNDL: EXIT FUNCTION
            CONTROL GET TEXT CBHNDL, %IDC_Unit TO s2
            CONTROL GET TEXT CBHNDL, %IDC_Price TO s3
            IF itemNo THEN deleteItem -itemNo 'delete item w/o listing
            INCR numItems
            REDIM PRESERVE items(numItems)
            REDIM PRESERVE order(numItems)
            order(numItems) = numItems
            itemNo = numItems
            CONTROL HANDLE CBHNDL, %IDC_Item TO hCtrl 
            s1 = truncateStr(hCtrl, s1, 132)
            s2 = truncateStr(hCtrl, s2, 132)
            items(itemNo).item = s1
            items(itemNo).unit = s2
            items(itemNo).cost = VAL(s3)
            CONTROL SEND CBHNDL, %IDC_Catg, %CB_GETCURSEL, 0, 0 TO i
            items(itemNo).catg = i + 1
            IF special THEN 
               buy = 1: nBuy = 1
               BIT SET items(itemNo).flag, 1
            END IF
            BIT CALC items(itemNo).flag, 0, buy
            items(itemNo).nUnits = nBuy
            fileChanged = 1: noReturn = 1: reorderList itemNo
            DIALOG END CBHNDL  
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF            
   END SELECT
END FUNCTION

SUB deleteItem(n AS LONG)
   'delete stored item order(n)
   'n > 0  delete item and all items
   'n < 0  delete item without listing
   LOCAL i, j, k AS LONG 
   j = n: n = ABS(n): k = order(n)
   FOR i = 1 TO numItems 'adjust order()
      IF order(i) > k THEN DECR order(i)
   NEXT i
   ARRAY DELETE order(n)
   ARRAY DELETE items(k)
   DECR numItems: fileChanged = 1
   IF j > 0 THEN listItems MIN(n, numItems) 
END SUB

FUNCTION getDate(nDate AS dateType) AS STRING
   LOCAL day, mo, yr AS LONG
   day = nDate.day: mo = nDate.mo: yr = nDate.yr
   IF day THEN FUNCTION = RIGHT$("0" + TRIM$(STR$(mo)), 2) _ 
                 + "-" + RIGHT$("0" + TRIM$(STR$(day)), 2) _
                 + "-" + RIGHT$("0" + TRIM$(STR$(yr)), 2)      
END FUNCTION

FUNCTION validDate(sDate AS STRING) AS LONG
   'return -1 if valid date, otherwise 0
   'return sDate as "mm-dd-yy"
   LOCAL mo, day, yr AS LONG
   mo  = VAL(PARSE$(sDate, ANY "-/", 1))
   day = VAL(PARSE$(sDate, ANY "-/", 2))
   yr  = VAL(PARSE$(sDate, ANY "-/", 3))
   IF yr > 2000 THEN yr = yr - 2000
   IF yr < 0 OR yr > 99 THEN EXIT FUNCTION
   IF mo < 1 OR mo > 12 THEN EXIT FUNCTION 
   IF day < 1 OR day > daysInMonth(mo, yr + 2000) THEN EXIT FUNCTION
   sDate = RIGHT$("0" + TRIM$(STR$(mo)), 2) + "-" + RIGHT$("0" + TRIM$(STR$(day)), 2) _
         + "-" + RIGHT$("0" + TRIM$(STR$(yr)), 2)
   FUNCTION = -1      
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION JulianDate(sDate AS STRING) AS LONG
   LOCAL d, m, y, c AS LONG
   d = VAL(MID$(sDate, 4, 2)): m = VAL(LEFT$(sDate, 2)): y = VAL(RIGHT$(sDate, 2))
   IF y < 2000 THEN y = y + 2000 
   IF m < 3 THEN m = m + 12: DECR y
   c = 2 - y\100 + y\400
   FUNCTION = INT(1461 * (y + 4716)/4) + INT(153 * (m + 1)/5) + d + c - 1524
END FUNCTION

FUNCTION predictUnits(i AS LONG) AS SINGLE
   LOCAL j, k, mo1, day1, yr1, mo2, day2, yr2, totalDays, lastDays AS LONG
   LOCAL accUnits AS DOUBLE, s1, s2 AS STRING
   FOR j = 1 TO 5
      IF items(i).kUnits(j) THEN INCR k ELSE EXIT FOR
      IF j > 1 THEN accUnits = accUnits + items(i).kUnits(j)
   NEXT j
   IF k < 2 THEN EXIT FUNCTION
   mo1 = items(i).kDates(k - 2).mo
   day1 = items(i).kDates(k - 2).day
   yr1 = items(i).kDates(k - 2).yr + 2000
   s1 = TRIM$(STR$(mo1)) + "-" + TRIM$(STR$(day1)) + "-" + TRIM$(STR$(yr1)): validDate(s1)
   mo2 = items(i).kDates(k).mo
   day2 = items(i).kDates(k).day
   yr2 = items(i).kDates(k).yr + 2000
   s2 = TRIM$(STR$(mo2)) + "-" + TRIM$(STR$(day2)) + "-" + TRIM$(STR$(yr2)): validDate(s2)
   totalDays = JulianDate(s2) - JulianDate(s1)
   IF totalDays = 0 THEN EXIT FUNCTION
   lastDays = JulianDate(DATE$) - JulianDate(s2)
   FUNCTION = accUnits / totalDays * lastDays
END FUNCTION

FUNCTION getLastDate(i AS LONG) AS STRING
   LOCAL j, k AS LONG
   FOR j = 1 TO 5
      IF items(i).kUnits(j) THEN INCR k ELSE EXIT FOR
   NEXT j
   IF k THEN FUNCTION = getDate(items(i).kDates(k))
END FUNCTION

SUB openTheFile()
   LOCAL i, fileNo AS LONG, s AS STRING
   fileNo = FREEFILE
   OPEN thisFile FOR BINARY AS fileNo
   s = $Prog: GET fileNo, , s
   GET fileNo, , numItems
   GET fileNo, , numCatgs
   REDIM items(numItems)
   REDIM order(numItems)
   REDIM catgs(numCatgs)
   FOR i = 1 TO numItems
      GET fileNo, , order(i)
   NEXT i
   FOR i = 1 TO numItems
      GET fileNo, , items(i)
   NEXT i
   s = SPACE$(20)
   FOR i = 1 TO numCatgs
      GET fileNo, , s: catgs(i) = s
   NEXT i 
   CLOSE fileNo
   fileChanged = 0
   s = PARSE$(thisFile, ".", 1)
   DIALOG SET TEXT hMain, s
END SUB

SUB saveTheFile()
   LOCAL i, fileNo AS LONG, s AS STRING, sf AS STRING * 20
   IF LEN(thisFile) = 0 THEN 
      DIALOG SEND hMain, %WM_COMMAND, %IDM_SaveAs, 0: EXIT SUB
   END IF
   fileNo = FREEFILE
   OPEN thisFile FOR BINARY AS fileNo
   s = $Prog
   PUT fileNo, , s 
   PUT fileNo, , numItems
   PUT fileNo, , numCatgs 
   FOR i = 1 TO numItems
      PUT fileNo, , order(i)
   NEXT i
   FOR i = 1 TO numItems
      PUT fileNo, , items(i)
   NEXT i
   FOR i = 1 TO numCatgs
      sf = catgs(i): PUT fileNo, , sf
   NEXT i
   CLOSE fileNo
   fileChanged = 0
   fileNo = FREEFILE
   OPEN "grocery.ini" FOR OUTPUT AS #fileNo
   PRINT #fileNo, thisFile
   CLOSE #fileNo
END SUB

FUNCTION myInput(OPT BYVAL prompt AS STRING, BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string for sizing of textbox
   LOCAL hInput, hdc, nStyle, hFont, wi, w1, w2, w3 AS LONG
   LOCAL t AS SIZEL, sz AS ASCIIZ * 256, inputStrPtr AS ASCIIZ PTR
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, 0, ti, , , wi, 75, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = t.cx * 1.2
   sz = ti: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = t.cx
   ReleaseDC hInput, hdc 
   IF w2 = 0 THEN w2 = 130
   wi = MAX(w1 + w2, w3)
   IF wi = 0 THEN wi = 150
   wi = MAX(wi, 150)
   DIALOG SET SIZE hInput, wi + 40, 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 5, 15, w2 + 5, 20
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", wi - 50, 50, 60, 25
   CONTROL SET FOCUS hInput, 9999
   DIALOG SHOW MODAL hInput, CALL myInputProc TO inputStrPtr
   FUNCTION = @inputStrPtr 'return myInputStr
END FUNCTION 

CALLBACK FUNCTION myInputProc()
   LOCAL myInputStr AS ASCIIZ*256, inputStrPtr AS ASCIIZ PTR
   SELECT CASE CBMSG
      CASE %WM_COMMAND
         IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
            IF CBCTL = %IDOK THEN CONTROL GET TEXT CBHNDL, 9999 TO myInputStr
            inputStrPtr = VARPTR(myInputStr)
            DIALOG END CBHNDL, inputStrPtr
         END IF
   END SELECT 
END FUNCTION

SUB categories()
   LOCAL wi, ht AS LONG, s AS STRING
   wi = 240: ht = 190
   DIALOG NEW PIXELS, hMain, "Categories", , , wi, ht, %WS_SYSMENU TO hCatg
   CONTROL ADD COMBOBOX, hCatg, %IDC_CatgCB, , 90, 20, 140, 135, %WS_VSCROLL OR %CBS_SIMPLE
   CONTROL ADD BUTTON, hCatg, %IDC_CatgAdd, "&Add", 10, 20, 60, 30
   CONTROL ADD BUTTON, hCatg, %IDC_CatgDel, "&Delete", 10, 55, 60, 30
   CONTROL ADD BUTTON, hCatg, %IDC_CatgChg, "&Change", 10, 90, 60, 30
   CONTROL ADD BUTTON, hCatg, %IDC_CatgSave, "&Save", 10, 125, 60, 30
   s = "Shft + Up/Down to reorder catgs"
   CONTROL ADD LABEL, hCatg, -1, s, 90, 160, 140, 12
   DIALOG SHOW MODAL hCatg CALL catgProc
END SUB

CALLBACK FUNCTION catgProc()
   LOCAL i, k, m, n, swapped, hAccel AS LONG
   LOCAL s AS STRING, sz AS ASCIIZ*64
   STATIC index, savNumCatgs AS LONG
   STATIC sTemp() AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CBHNDL, %IDC_CatgCB
         FOR i = 1 TO numCatgs
            COMBOBOX ADD CBHNDL, %IDC_CatgCB, catgs(i)
         NEXT i
         CONTROL HANDLE CBHNDL, %IDC_CatgCB TO hCombo
         REDIM sTemp(numCatgs)
         FOR i = 1 TO numCatgs
            sTemp(i) = catgs(i)
         NEXT i
         savNumCatgs = numCatgs
         'accelerator keys for this dialog
         REDIM ac(1:2) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY OR %FSHIFT
         ac(1).key = %VK_UP
         ac(1).cmd =  %IDC_ShftUp
         ac(2).fvirt = %FVIRTKEY OR %FSHIFT
         ac(2).key = %VK_DOWN
         ac(2).cmd =  %IDC_ShftDn
         ACCEL ATTACH CBHNDL, ac() TO hAccel
      CASE %WM_COMMAND
         IF CBCTL = %IDC_CatgCB THEN
            CONTROL SEND CBHNDL, %IDC_CatgCB, %CB_GETCURSEL, 0, 0 TO n: INCR n
            IF n > 0 THEN index = n: listboxItem = n
         ELSEIF CBCTL = %IDOK OR CBCTL = %IDC_CatgAdd THEN
            CONTROL GET TEXT CBHNDL, %IDC_CatgCB TO s
            INCR numCatgs: REDIM PRESERVE catgs(numCatgs)
            catgs(numCatgs) = LCASE$(s)
            COMBOBOX ADD CBHNDL, %IDC_CatgCB, LCASE$(s)
            CONTROL SET TEXT CBHNDL, %IDC_CatgCB, "" 
            CONTROL SET FOCUS CBHNDL, %IDC_CatgCB
            fileChanged = 1
         ELSEIF CBCTL = %IDC_CatgDel THEN
            CONTROL SEND CBHNDL, %IDC_CatgCB, %CB_GETCURSEL, 0, 0 TO n: INCR n
            IF n THEN
               k = MSGBOX("Delete category now?", %MB_YESNO OR %MB_ICONWARNING, catgs(n))
               IF k = %IDYES THEN
                  ARRAY DELETE catgs(n): DECR numCatgs
                  COMBOBOX DELETE CBHNDL, %IDC_CatgCB, n
                  FOR i = 1 TO numItems
                     k = order(i)
                     IF items(k).catg = n THEN items(k).catg = 0
                     IF items(k).catg > n THEN DECR items(k).catg
                  NEXT i
                  fileChanged = 1: reorderList
               END IF
            END IF
         ELSEIF CBCTL = %IDC_CatgChg THEN
            CONTROL GET TEXT CBHNDL, %IDC_CatgCB TO s
            COMBOBOX SELECT CBHNDL, %IDC_CatgCB, listboxItem
            IF listboxItem THEN
               s = myInput("Category:  ", "Change Category", s)
               IF LEN(s) THEN
                  catgs(listboxItem) = s
                  COMBOBOX RESET CBHNDL, %IDC_CatgCB
                  FOR i = 1 TO numCatgs
                     COMBOBOX ADD CBHNDL, %IDC_CatgCB, catgs(i)
                  NEXT i
                  fileChanged = 1
               END IF
            END IF
         ELSEIF CBCTL = %IDC_ShftUp OR CBCTL = %IDC_ShftDn THEN
            IF CBCTL = %IDC_ShftUp THEN
               IF listboxItem = 1 THEN EXIT SELECT
               n = listboxItem: m = n - 1: swapped = 1
            ELSE
               IF listboxItem = numCatgs THEN EXIT SELECT
               n = listboxItem: m = n + 1: swapped = 1
            END IF
            IF swapped THEN
               k = SGN(n - m)
               SendMessage hCombo, %CB_GETLBTEXT, m - 1, VARPTR(sz)
               SendMessage hCombo, %CB_DELETESTRING, m - 1, 0
               SendMessage hCombo, %CB_INSERTSTRING, m - 1 + k, VARPTR(sz)
               SendMessage hCombo, %CB_SETCURSEL, m - 1, 0
               listboxItem = listboxItem - k
            END IF  
         ELSEIF CBCTL = %IDC_CatgSave THEN
            FOR i = 1 TO numCatgs
               CONTROL SEND CBHNDL, %IDC_CatgCB, %CB_GETLBTEXT, i - 1, VARPTR(sz)
               catgs(i) = sz
            NEXT i
            FOR i = 1 TO numItems
               sz = sTemp(items(i).catg)
               CONTROL SEND CBHNDL, %IDC_CatgCB, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO n
               items(i).catg = n + 1
            NEXT i
            fileChanged = 1: listItems: DIALOG END CBHNDL
         END IF
         IF CBCTL >= %IDC_CatgAdd AND CBCTL <= %IDC_CatgSave THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            numCatgs = savNumCatgs
            FOR i = 1 TO numCatgs
               catgs(i) = sTemp(i)
            NEXT i
         END IF        
   END SELECT
END FUNCTION

SUB reorderList(OPT BYVAL nOpt AS LONG )
   LOCAL i, k AS LONG
   DIM x(numItems) AS STRING
   FOR i = 1 TO numItems
      k = order(i)
      x(i) = STR$(items(k).catg) + items(k).item
   NEXT i
   ARRAY SORT x(), TAGARRAY order()
   k = 1
   IF nOpt > 0 THEN
      FOR i = 1 TO numItems
         IF order(i) = nOpt THEN k = i: EXIT FOR
      NEXT i
   END IF
   listItems k
END SUB

SUB printList(OPT BYVAL nOpt AS LONG)
   'nOpt = 0 print entire list of items
   '     = 1 print only items to buy
   '-----------------------------------------------------
   LOCAL i, j, xppi, yppi, lineCount, lineIncr, maxLines, itemsTobuy AS LONG 
   LOCAL x1, x2, x3, x4, x5, x6, x, y, xc, yc, u, v AS SINGLE
   LOCAL s, lastCatg AS STRING
   XPRINT ATTACH CHOOSE
   XPRINT GET PPI TO xppi, yppi
   XPRINT CHR SIZE TO xc, yc
   XPRINT GET LINES TO maxLines
   maxLines = maxLines - 4
   x1 = 0.50 * xppi 
   x2 = 2.00 * xppi 
   x3 = 3.50 * xppi
   x4 = 5.00 * xppi 
   x5 = 6.50 * xppi
   x6 = 7.50 * xppi   
   lineCount = maxLines
   IF nOpt THEN lineIncr = 2 ELSE lineIncr = 1
   FOR j = 1 TO numItems
      IF lineCount >= maxLines THEN 'new page - print title
         y = 2*yc
         XPRINT FONT "MS Sans Serif", 11, 5 
         XPRINT SET POS (x1+2*xc, y): XPRINT "Catg"
         XPRINT SET POS (x2+2*xc, y): XPRINT "Item"
         XPRINT SET POS (x3+2*xc, y): XPRINT "Unit Descr"
         XPRINT SET POS (x4, y): XPRINT "Last Buy"
         XPRINT SET POS (x5 - 5*xc, y): XPRINT "Units"
         XPRINT SET POS (x6 - 5*xc, y): XPRINT "Cost"
         XPRINT FONT "MS Sans Serif", 11, 0
         XPRINT: lineCount = 2: lastCatg = ""
      END IF
      i = order(j)
      IF nOpt AND BIT(items(i).flag, 0) = 0 THEN ITERATE
      XPRINT GET POS TO x, y: lineCount = lineCount + lineIncr
      IF catgs(items(i).catg) <> lastCatg THEN
         lastCatg = catgs(items(i).catg)
         XPRINT SET POS (x1, y): XPRINT catgs(items(i).catg)
      END IF
      XPRINT SET POS (x2, y): XPRINT items(i).item
      XPRINT SET POS (x3, y): XPRINT items(i).unit
      XPRINT SET POS (x4, y): XPRINT getLastDate(i)
      u = items(i).nUnits
      IF u THEN 
         s = FORMAT$(u, "#.00")
         XPRINT SET POS (x5 - xc * LEN(s), y): XPRINT s
         v = u * items(i).cost: s = FORMAT$(v, "#.00")
         IF v THEN XPRINT SET POS (x6 - xc * LEN(s), y): XPRINT s
         INCR itemsToBuy 
      END IF
      IF itemsTobuy < totalToBuy AND lineCount >= maxLines THEN XPRINT FORMFEED
      IF nOpt THEN XPRINT  'double space
   NEXT j
   XPRINT CLOSE
END SUB

SUB checkout()
   DIALOG NEW PIXELS, hMain, "Check Out", , , 200, 120, %WS_SYSMENU TO hCheckOut
   CONTROL ADD LABEL, hCheckOut, -1, "Check out date: ", 10, 10, 80, 16
   CONTROL ADD TEXTBOX, hCheckOut, 301, DATE$, 95, 10, 70, 20
   CONTROL ADD CHECKBOX, hCheckOut, 302, "Update checkout prices", 10, 42, 200, 20
   CONTROL ADD BUTTON, hCheckOut, %IDOK, "Ok", 90, 80, 60, 30
   DIALOG SHOW MODAL hCheckOut CALL checkOutProc
END SUB

CALLBACK FUNCTION checkoutProc()
   LOCAL i, j, m, n, count AS LONG, v AS SINGLE
   LOCAL s AS STRING, ckoutDate AS dateType
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
      CASE %WM_COMMAND
         SELECT CASE CBCTL
         CASE %IDOK
            CONTROL GET TEXT CBHNDL, 301 TO s
            IF NOT validDate(s) THEN
               MSGBOX "Must enter valid date", %MB_ICONERROR, "Invalid Date"
               CONTROL SET FOCUS CBHNDL, 301: EXIT FUNCTION
            END IF
            ckoutDate.mo = VAL(LEFT$(s, 2))
            ckoutDate.day = VAL(MID$(s, 4, 2))
            ckoutDate.yr = VAL(RIGHT$(s, 2))
            CONTROL GET CHECK CBHNDL, 302 TO n
            DIALOG END CBHNDL
            IF n THEN
               FOR i = 1 TO numItems
                  n = order(i)
                  IF BIT(items(n).flag, 0) THEN 
                     v = checkoutPrice(n): INCR count
                     IF v > 0 THEN items(n).cost = v
                  END IF
                  IF count = totalToBuy OR v < 0 THEN EXIT FOR
               NEXT i
            END IF
            FOR n = 1 TO numItems 'now process histories
               i = order(n): m = 0
               IF BIT(items(i).flag, 0) = 0 THEN ITERATE
               IF BIT(items(i).flag, 1) THEN ITERATE
               FOR j = 1 TO 5 'find index of last date
                  IF items(i).kDates(j).day THEN m = j ELSE EXIT FOR
               NEXT u
               IF m = 5 THEN 'make room for new entries 
                  FOR j = 1 TO 4
                     items(i).kUnits(j) = items(i).kUnits(j + 1)
                     items(i).kDates(j) = items(i).kDates(j + 1)
                  NEXT j
               ELSE
                  INCR m
               END IF
               items(i).kDates(m) = ckoutDate
               items(i).kUnits(m) = items(i).nUnits
               BIT RESET items(i).flag, 0
               BIT RESET items(i).flag, 1
               items(i).nUnits = 0
            NEXT n
            n = numItems
            FOR j = 1 TO n 'remove special buys
               IF BIT(items(order(j)).flag, 1) THEN deleteItem -j
            NEXT j
            totalToBuy = 0: totalCost = 0
            fileChanged = 1: listItems
            MSGBOX "Checkout is done  ", %MB_ICONINFORMATION, "Checkout"
         CASE %IDCANCEL
            DIALOG END CBHNDL
         END SELECT
   END SELECT
END FUNCTION   

FUNCTION checkoutPrice(n AS LONG) AS SINGLE
   LOCAL hPrice AS LONG, result AS SINGLE
   DIALOG NEW PIXELS, hMain, "Check Out", , , 220, 150, %WS_SYSMENU TO hPrice
   CONTROL ADD LABEL, hPrice, 303, "", 10, 10, 200, 16 
   CONTROL ADD LABEL, hPrice, -1, "Units bought:", 10, 40, 80, 20
   CONTROL ADD TEXTBOX, hPrice, 304, "", 80, 38, 50, 20
   CONTROL ADD LABEL, hPrice, -1, "Checkout Price:", 10, 70, 80, 20
   CONTROL ADD TEXTBOX, hPrice, 305, "", 95, 68, 70, 20
   CONTROL ADD BUTTON, hPrice, %IDOK, "Next", 70, 105, 60, 30
   result = 0: DIALOG SET USER hPrice, 1, n
   DIALOG SET USER hPrice, 2, VARPTR(result)
   DIALOG SHOW MODAL hPrice CALL checkoutPriceProc
   FUNCTION = result
END FUNCTION

CALLBACK FUNCTION checkoutPriceProc()
   LOCAL s AS STRING, v, v1 AS SINGLE
   STATIC itemNo AS LONG, pRes AS SINGLE PTR
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      DIALOG GET USER CBHNDL, 1 TO itemNo
      DIALOG GET USER CBHNDL, 2 TO pRes
      CONTROL SET TEXT CBHNDL, 303, "Item: " + items(itemNo).item
      CONTROL SET TEXT CBHNDL, 304, FORMAT$(items(itemNo).nUnits, "#.00")
      v = items(itemNo).nUnits * items(itemNo).cost
      CONTROL SET TEXT CBHNDL, 305, FORMAT$(v, "#.00")   
   CASE %WM_COMMAND
      IF CBCTL = %IDOK THEN
         noReturn = 1
         CONTROL GET TEXT CBHNDL, 305 TO s: v = VAL(s)
         CONTROL GET TEXT CBHNDL, 304 TO s: v1 = VAL(s)
         IF v1 THEN v = v/v1
         @pRes = v: DIALOG END CBHNDL
      ELSEIF CBCTL = 304 AND CBCTLMSG = %EN_CHANGE THEN
         CONTROL GET TEXT CBHNDL, 304 TO s
         v = VAL(s) * items(itemNo).cost 
         CONTROL SET TEXT CBHNDL, 305, FORMAT$(v, "#.00")   
      END IF
   CASE %WM_SYSCOMMAND
      IF CBCTL = %SC_CLOSE THEN DIALOG END CBHNDL, -1 
   END SELECT
END FUNCTION

FUNCTION MakeFont(BYVAL fName AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL attr AS STRING) AS DWORD 
   '--------------------------------------------------------------------
   ' Create a desired font and return its handle.
   ' attr = "biu" for bold, italic, and underlined (any order)
   '--------------------------------------------------------------------
   LOCAL hDC AS DWORD, CharSet AS LONG, CyPixels AS LONG 
   LOCAL bold, italic, uLine AS LONG
   IF LEN(attr) THEN                             
      IF INSTR(LCASE$(attr), "b") THEN bold = %FW_BOLD
      IF INSTR(LCASE$(attr), "i") THEN italic = 1
      IF INSTR(LCASE$(attr), "u") THEN uLine = 1
   END IF
   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   'enumFontFamilies hDC, BYVAL STRPTR(fName), CODEPTR(enumCharSet), BYVAL VARPTR(CharSet)
   ReleaseDC %HWND_DESKTOP, hDC
   PtSize = 0 - (ptSize * CyPixels) \ 72
   FUNCTION = CreateFont(ptSize, 0, 0, 0, bold, italic, uLine, _
             %FALSE, CharSet, %OUT_TT_PRECIS, _
             %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
             %FF_DONTCARE , BYCOPY fName)
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
SUB About
   LOCAL hAbout AS LONG, s, ti AS STRING
   s = "Grocery List for Windows" + $CRLF + $CRLF _
     + "Version number " + $verNo + " - Free distribution" + $CRLF _
     + "by Charles G. Dietz"
   ti = "About My Grocery List"
   DIALOG NEW hMain, ti,,, 200, 140, %WS_SYSMENU OR %DS_MODALFRAME TO hAbout
   CONTROL ADD LABEL, hAbout, -1, s, 50, 10, 140, 35, %SS_NOPREFIX
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, %IDC_Email, s, 50, 50, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, %IDC_WebAddr, s, 50, 65, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD BUTTON, hAbout, %IDOK, "OK", 85, 90, 50, 25
   CONTROL ADD IMAGE, hAbout, -1, "grocery", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB

CALLBACK FUNCTION aboutProc() AS LONG
   'LOCAL hAboutFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   STATIC hAboutFont AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      hAboutFont = makeFont("MS Sans Serif", 10, "u")
   CASE %WM_PAINT
      CONTROL SET COLOR CBHNDL, %IDC_Email, %BLUE, -1
      CONTROL SEND CBHNDL, %IDC_Email, %WM_SETFONT, hAboutFont, 1
      CONTROL SET COLOR CBHNDL, %IDC_WebAddr, %BLUE, -1
      CONTROL SEND CBHNDL, %IDC_WebAddr, %WM_SETFONT, hAboutFont, 1
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= %IDC_Email THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CBHNDL, %DWL_MSGRESULT, 1: FUNCTION = 1 
      END IF 
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN 
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDC_Email THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)   
      ELSEIF CBCTL = %IDC_WebAddr THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   CASE %WM_DESTROY
      DeleteObject hAboutFont
   END SELECT
END FUNCTION
