'Ver 1.30
'  - changed flags for open to allow new file to be defined
'  - corrected doubling of edited entry
'  - added dialog to change checkout prices
'Ver 1.31
'  - corrected exit from File menu
'Ver 1.32
'  - corrected item definition and units when specifying prices during checkout
'Ver 1.40
'  - Added reminder to buy before printing grocery list
'Ver 1.41
'  - corrected problem when running program before any data file is created
'Ver 1.42
'  - moved creation of hMouseMenu to addMenu sub (create once)
'Ver 1.50
'  - removed "have you forgotten" dialog box from Print button
'  - added 'buy/don't buy' to floating mouse menu
'  - prompt to update items checked if not what was actually bought
'  - added 'units bought' textbox to 'Checkout Price' dialog box
'--------------------------------------------------------------------------------------------

'main dialog id's
%IDC_MainLB       = 100
%IDC_Units        = 101 
%IDC_NewItem      = 121
%IDC_AutoList     = 122
%IDC_PrnList      = 123
%IDC_CheckOut     = 124
'add item dialog id's
%IDC_Item         = 201
%IDC_Unit         = 202
%IDC_Price        = 203
%IDC_Catg         = 204
%IDC_Special      = 205
%IDC_Ok           = 206
%IDC_CatgCB       = 220
%IDC_CatgAdd      = 221
%IDC_CatgDel      = 222
%IDC_CatgChg      = 223
%IDC_CatgSave     = 224
%IDC_ShftUp       = 225
%IDC_ShftDn       = 226
%IDC_Email        = 301
%IDC_WebAddr      = 302
'menu id's
%IDM_Open         = 301
%IDM_Save         = 302
%IDM_SaveAs       = 303
%IDM_ResetAll     = 304
%IDM_Print        = 305
%IDM_Exit         = 306
%IDM_New          = 311
%IDM_Chg          = 312
%IDM_Delete       = 313
%IDM_Reset        = 314
%IDM_Buy          = 315
%IDM_BuyUnits     = 316
%IDM_UnitsHist    = 317
%IDM_PrnList      = 321
%IDM_Checkout     = 322
%IDM_UndoCheckOut = 323
%IDM_Catg         = 324
%IDM_Help         = 331
%IDM_About        = 332

TYPE dateType '2 byte dates
   day AS BIT * 5 IN WORD   'day = 1-31
   mo  AS BIT * 4           'month = 1-12
   yr  AS BIT * 7           'yr = 1-128 (year = yr + 2000)
END TYPE

TYPE ItemType '79 bytes
   catg            AS BYTE        'category of item
   item            AS STRING * 20 'item definition
   unit            AS STRING * 20 'item description
   cost            AS SINGLE      'item cost per unit
   nUnits          AS SINGLE      'units to buy
   kDates(1 TO 5)  AS dateType    '5 dates kept for tracking
   kUnits(1 TO 5)  AS SINGLE      '5 units kept for tracking
   flag            AS BYTE        'bit 0 = buy, 1 = excl tracking, 2 = auto list
END TYPE

GLOBAL hMain AS LONG
GLOBAL hMenu AS LONG
GLOBAL hStatus AS LONG
GLOBAL hCheckout AS LONG
GLOBAL hCatg AS LONG 
GLOBAL hCombo AS LONG
GLOBAL hFileMenu AS LONG
GLOBAL hEditMenu AS LONG
GLOBAL hTaskMenu AS LONG
GLOBAL hHelpMenu AS LONG
GLOBAL hMouseMenu AS LONG
GLOBAL gOrigEditProc AS LONG
GLOBAL gOrigLBProc AS LONG
GLOBAL thisFile AS STRING
GLOBAL fileChanged AS LONG
GLOBAL editMode AS LONG
GLOBAL noReturn AS LONG
GLOBAL numItems AS LONG
GLOBAL numCatgs AS LONG
GLOBAL update AS LONG
GLOBAL listboxItem AS LONG
GLOBAL totalToBuy AS LONG
GLOBAL totalCost AS DOUBLE
GLOBAL items() AS itemType
GLOBAL order() AS LONG
GLOBAL catgs() AS STRING
GLOBAL backUp() AS itemType
GLOBAL backUpOrder() AS LONG

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
DECLARE FUNCTION validDate(STRING) AS LONG
DECLARE FUNCTION JulianDate(STRING) AS LONG
DECLARE FUNCTION daysInMonth(LONG, LONG) AS LONG
DECLARE FUNCTION predictUnits(LONG) AS SINGLE
DECLARE FUNCTION getDate(dateType) AS STRING
DECLARE FUNCTION getLastDate(i AS LONG) AS STRING
DECLARE FUNCTION truncateStr(LONG, STRING, LONG) AS STRING
DECLARE FUNCTION checkoutPrice(LONG) AS SINGLE
DECLARE FUNCTION myInput(OPT BYVAL STRING, BYVAL STRING, BYVAL STRING) AS STRING
DECLARE FUNCTION MakeFont(BYVAL STRING, BYVAL LONG, OPT BYVAL STRING) AS DWORD 
DECLARE SUB addMenu()
DECLARE SUB addStatusbar()
DECLARE SUB setStatusbar()
DECLARE SUB openTheFile()
DECLARE SUB saveTheFile()
DECLARE SUB initMainLB()
DECLARE SUB listItems(OPT BYVAL LONG)
DECLARE SUB fillEntryBox(LONG)
DECLARE SUB deleteItem(LONG)
DECLARE SUB addItem(OPT BYVAL LONG)
DECLARE SUB printList(OPT BYVAL LONG)
DECLARE SUB reorderList(OPT BYVAL LONG)
DECLARE SUB checkout()
DECLARE SUB categories()
DECLARE SUB about()
